/*
Copyright (C) (2020) (Mathieu Bergeron) (mathieu.bergeron@cmontmorency.qc.ca)

This file is part of Ntro, an application framework designed with teaching in mind.

This is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <https://www.gnu.org/licenses/>.

*/
package ca.ntro.app.services;

import ca.ntro.app.models.Model;
import ca.ntro.core.stream.Stream;
import ca.ntro.ntro_app_fx_impl.modified.Observable;
import ca.ntro.ntro_app_fx_impl.modified.ObservationNtro;

public interface ModelStore {
	
	void watch(Class<? extends Observable> modelClass);
	void watch(Class<? extends Observable> modelClass, String modelId);
	
	<M extends Model> M load(Class<?> modelClass);
	<M extends Model> M load(Class<?> modelClass, String modelId);

	void save(Class<?> modelClass, String modelId, Object model);
	void save(Class<?> modelClass, Object model);

	<M extends Model> void delete(Class<M> modelClass);
	<M extends Model> void delete(Class<M> modelClass, String modelId);

	ObservationNtro getCurrentModelObservation(Class<? extends Observable> modelClass, String modelId);

	void suspendDiskOperations();
	void resumeDiskOperations();
	
	void writeModelFiles();
	void writeGraphs();

	Stream<Model> modelStream();

}
