/*
Copyright (C) (2020) (Mathieu Bergeron) (mathieu.bergeron@cmontmorency.qc.ca)

This file is part of Ntro, an application framework designed with teaching in mind.

This is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <https://www.gnu.org/licenses/>.

*/
package ca.ntro.ntro_app_fx_impl.modified;

import ca.ntro.app.modified.Modified;
import ca.ntro.app.modified.Snapshot;

public class ObservationNtro<O extends Observable> 
       extends SnapshotNtro<O>

       implements Observation<O>,
                  Modified<O>,
                  Snapshot<O> {
	
	private O previousValue;

	public O getPreviousValue() {
		return previousValue;
	}

	public void setPreviousValue(O previousValue) {
		this.previousValue = previousValue;
	}


	@Override
	public O previousValue() {
		return getPreviousValue();
	}
}
