/*
Copyright (C) (2020) (Mathieu Bergeron) (mathieu.bergeron@cmontmorency.qc.ca)

This file is part of Ntro, an application framework designed with teaching in mind.

This is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <https://www.gnu.org/licenses/>.

*/
package ca.ntro.ntro_app_fx_impl.services;

import ca.ntro.app.modified.Modified;
import ca.ntro.app.modified.Snapshot;
import ca.ntro.core.NtroCore;
import ca.ntro.ntro_app_fx_abstr.messages.MessageAbstr;
import ca.ntro.ntro_app_fx_impl.messages.MessageServiceImpl;
import ca.ntro.ntro_app_fx_impl.modified.Observation;
import ca.ntro.ntro_core_impl.task_graphs.task_graph.SimpleTask;

public class MessageServiceJdk extends MessageServiceImpl {

	@Override
	protected void addMessageToMessageHandlerTask(SimpleTask handler, MessageAbstr message) {
		NtroCore.threads().runOnMainThread(() -> {
			handler.addResult(message);
		});
	}

	@Override
	protected void addObservationToObservationHandlerTask(SimpleTask handler, Observation<?> observation) {
		NtroCore.threads().runOnMainThread(() -> {
			handler.addResult((Modified<?>) observation);
		});
	}
	
	@Override
	protected void addSnapshotToSnapshotHandlerTask(SimpleTask handler, Snapshot<?> snapshot) {
		NtroCore.threads().runOnMainThread(() -> {
			handler.addResult(snapshot);
		});
	}

}
