/*
Copyright (C) (2020) (Mathieu Bergeron) (mathieu.bergeron@cmontmorency.qc.ca)

This file is part of Ntro, an application framework designed with teaching in mind.

This is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <https://www.gnu.org/licenses/>.

*/
package ca.ntro.ntro_app_fx_impl.world2d.region_tree;

import ca.ntro.core.stream.Stream;

public interface RegionTree2dNode<R extends Region2d> extends AnonymousRegion2d {

	void add(R region, double epsilon);

	void remove(R region, double epsilon);

	Stream<R> get(AnonymousRegion2d regionSpec, double epsilon);

	Stream<R> get(double topLeftX,
			      double topLeftY,
			      double width,
			      double height,
			      double epsilon);

	Stream<R> intersectWith(AnonymousRegion2d otherRegion, double epsilon);

	Stream<R> intersectWith(double topLeftX,
			                double topLeftY,
			                double width,
			                double height,
			                double epsilon);

	Stream<R> containedIn(AnonymousRegion2d otherRegion, double epsilon);

	Stream<R> containedIn(double topLeftX,
			              double topLeftY,
			              double width,
			              double height,
			              double epsilon);

}
