/*
Copyright (C) (2020) (Mathieu Bergeron) (mathieu.bergeron@cmontmorency.qc.ca)

This file is part of Ntro, an application framework designed with teaching in mind.

This is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <https://www.gnu.org/licenses/>.

*/
package ca.ntro.ntro_core_impl.exceptions;

import java.util.ArrayList;
import java.util.List;

import ca.ntro.ntro_core_impl.wrappers.future.ExceptionHandler;

public class ExceptionCatcherNtro<R extends Object> implements ExceptionCatcher<R> {
	
	private List<Throwable> exceptions = new ArrayList<>();

	@SuppressWarnings("unchecked")
	@Override
	public R handleException(ExceptionHandler exceptionHandler) {
		for(Throwable t : exceptions) {
			exceptionHandler.handle(t);
		}
		
		exceptions.clear();

		return (R) this;
	}
	
	protected void memorizeException(Throwable t) {
		exceptions.add(t);
	}

}
