/*
Copyright (C) (2020) (Mathieu Bergeron) (mathieu.bergeron@cmontmorency.qc.ca)

This file is part of Ntro, an application framework designed with teaching in mind.

This is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <https://www.gnu.org/licenses/>.

*/
package ca.ntro.ntro_core_impl.wrappers.optionnal;

public class OptionnalNtro<V extends Object> implements Optionnal<V> {

	private boolean hasValue = false;
	private V value = null;
	
	public OptionnalNtro(V value) {
		registerValue(value);
	}
	
	public OptionnalNtro() {
	}

	public void registerValue(V value) {
		this.hasValue = true;
		this.value = value;
	}

	public void forgetValue() {
		this.hasValue = false;
		this.value = null;
	}

	@Override
	public boolean hasValue() {
		return hasValue;
	}

	@Override
	public V value() {
		return value;
	}
}
