package pong;

import ca.ntro.app.NtroAppFx;
import ca.ntro.app.backend.BackendRegistrar;
import ca.ntro.app.frontend.FrontendRegistrarFx;
import ca.ntro.app.messages.MessageRegistrar;
import ca.ntro.app.models.ModelRegistrar;
import pong.commun.messages.MsgAjouterPoint;
import pong.commun.modeles.ModeleSauvegarde;
import pong.commun.modeles.ModelePartie;
import pong.commun.monde2d.Balle2d;
import pong.commun.monde2d.MondePong2d;
import pong.commun.monde2d.Palette2d;
import pong.commun.valeurs.InfoJoueur;
import pong.commun.valeurs.Joueur;
import pong.dorsal.DorsalPong;
import pong.frontal.FrontalPong;


public class AppPong implements NtroAppFx {
	
	public static void main(String[] args) {
		NtroAppFx.launch(args);
	}
	
	@Override
	public void registerFrontend(FrontendRegistrarFx registrar) {
		registrar.registerFrontend(FrontalPong.class);
	}

	@Override
	public void registerMessages(MessageRegistrar registrar) {
		registrar.registerMessage(MsgAjouterPoint.class);
	}

	@Override
	public void registerModels(ModelRegistrar registrar) {
		registrar.registerModel(ModelePartie.class);
		registrar.registerModel(ModeleSauvegarde.class);
		registrar.registerValue(Joueur.class);
		registrar.registerValue(InfoJoueur.class);

		registrar.registerValue(MondePong2d.class);
		registrar.registerValue(Palette2d.class);
		registrar.registerValue(Balle2d.class);
	}

	@Override
	public void registerBackend(BackendRegistrar registrar) {
		registrar.registerBackend(DorsalPong.class);
	}

}
