package pong.commun.valeurs;

import java.util.Map;

import ca.ntro.app.Ntro;
import ca.ntro.app.models.ModelValue;
import pong.commun.enums.Action;
import pong.commun.enums.Position;
import pong.commun.monde2d.Balle2d;
import pong.frontal.evenements.EvtActionJoueur;
import pong.frontal.vues.VuePartie;

public class Joueur implements ModelValue {
	
	public String id;
	public String prenom;
	public String nom;

	public String getId() {
		return id;
	}

	public void setId(String id) {
		this.id = id;
	}

	public String getPrenom() {
		return prenom;
	}

	public void setPrenom(String prenom) {
		this.prenom = prenom;
	}

	public String getNom() {
		return nom;
	}

	public void setNom(String nom) {
		this.nom = nom;
	}

	public Joueur() {
	}

	public Joueur(String id, String prenom, String nom) {
		setId(id);
		setPrenom(prenom);
		setNom(nom);
	}

	@Override
	public String toString() {
		return nomComplet();
	}
	
	public String nomComplet() {
		return prenom + " " + nom;
	}
	
	@Override
	public boolean equals(Object autre) {
		boolean siEgal = false;
		
		if(autre == this) {

			siEgal = true;

		}else if(autre instanceof Joueur) {
			
			siEgal = siEgal((Joueur) autre);

		}

		return siEgal;
	}
	
	private boolean siEgal(Joueur autre) {
		return siMemeIdQue(autre)
				&& siMemePrenomQue(autre)
				&& siMemeNomQue(autre);
	}
	
	private boolean siMemeIdQue(Joueur autre) {
		boolean siMemeId = false;
		
		if(id == null && autre.id == null) {
			
			siMemeId = true;

		}else if(id != null) {
			
			siMemeId = id.equals(autre.id);

		}
		
		return siMemeId;
	}

	private boolean siMemePrenomQue(Joueur autre) {
		boolean siMemePrenom = false;
		
		if(prenom == null && autre.prenom == null) {
			
			siMemePrenom = true;

		}else if(prenom != null) {
			
			siMemePrenom = prenom.equals(autre.prenom);

		}
		
		return siMemePrenom;
	}

	private boolean siMemeNomQue(Joueur autre) {
		boolean siMemeNom = false;
		
		if(nom == null && autre.nom == null) {
			
			siMemeNom = true;

		}else if(nom != null) {
			
			siMemeNom = nom.equals(autre.nom);

		}
		
		return siMemeNom;
	}

	public boolean estJoueur(String idJoueur) {
		return this.id.equals(idJoueur);
	}


	public boolean siIdEst(String autreId) {
		boolean siIdEst = false;
		
		if(id != null) {
			siIdEst = id.equals(autreId);
		}
		
		return siIdEst;
	}

}
