package pong.dorsal.taches;

import static ca.ntro.app.tasks.backend.BackendTasks.*;

import ca.ntro.app.tasks.backend.BackendTasks;
import pong.commun.messages.MsgAjouterPoint;
import pong.commun.modeles.ModelePartie;
import pong.commun.modeles.ModeleSauvegarde;

public class ModifierPartie {
	
	public static void creerTaches(BackendTasks tasks) {
		
		tasks.taskGroup("ModifierPartie")
		
			 .waitsFor(model(ModelePartie.class))

			 .waitsFor(model(ModeleSauvegarde.class))
		
		      .contains(subTasks -> {

		    	  	ajouterPoint(subTasks);

		      });
	}

	private static void ajouterPoint(BackendTasks tasks) {

		tasks.task("ajouterPoint")

			 .waitsFor(model(ModelePartie.class))

			 .waitsFor(model(ModeleSauvegarde.class))

		     .waitsFor(message(MsgAjouterPoint.class))

		     .executes(inputs -> {
		    	 
				 MsgAjouterPoint  msgAjouterPoint = inputs.get(message(MsgAjouterPoint.class));
				 ModelePartie     partie          = inputs.get(model(ModelePartie.class));
				 ModeleSauvegarde sauvegarde      = inputs.get(model(ModeleSauvegarde.class));
				 
				 msgAjouterPoint.ajouterPointA(partie);
				 
				 msgAjouterPoint.sauvegarderDans(sauvegarde);

		     });
	}

}