package pong.frontal;

import ca.ntro.app.Ntro;
import ca.ntro.app.events.EventRegistrar;
import ca.ntro.app.frontend.FrontendFx;
import ca.ntro.app.frontend.ViewRegistrarFx;
import ca.ntro.app.session.SessionRegistrar;
import ca.ntro.app.tasks.frontend.FrontendTasks;
import pong.frontal.donnees.DonneesVuePartie;
import pong.frontal.evenements.EvtActionJoueur;
import pong.frontal.evenements.EvtClicSouris;
import pong.frontal.taches.AfficherPartie;
import pong.frontal.taches.PremierAffichage;
import pong.frontal.vues.VuePartie;

public class FrontalPong implements FrontendFx {
	
	@Override
	public void createTasks(FrontendTasks tasks) {
		
		PremierAffichage.creerTaches(tasks);
		AfficherPartie.creerTaches(tasks);

	}

	@Override
	public void registerEvents(EventRegistrar registrar) {
		registrar.registerEvent(EvtActionJoueur.class);
		registrar.registerEvent(EvtClicSouris.class);
	}

	@Override
	public void registerViews(ViewRegistrarFx registrar) {
		registrar.registerDefaultLocale(Ntro.buildLocale("fr"));
		registrar.registerTranslations(Ntro.buildLocale("fr"), "/traductions/fr.properties");
		registrar.registerTranslations(Ntro.buildLocale("en"), "/traductions/en.properties");
		
		registrar.registerStylesheet("/style/prod.css");

		registrar.registerView(VuePartie.class, "/vues/partie.xml");

		registrar.registerViewData(DonneesVuePartie.class);
	}


	@Override
	public void registerSessionClass(SessionRegistrar registrar) {

	}

}
