package pong.frontal.taches;

import ca.ntro.app.frontend.Tick;
import ca.ntro.app.frontend.ViewLoader;
import ca.ntro.app.modified.Modified;
import ca.ntro.app.services.Window;
import ca.ntro.app.tasks.frontend.FrontendTasks;
import pong.commun.modeles.ModelePartie;
import pong.frontal.donnees.DonneesVuePartie;
import pong.frontal.evenements.EvtActionJoueur;
import pong.frontal.evenements.EvtClicSouris;
import pong.frontal.vues.VuePartie;

import static ca.ntro.app.tasks.frontend.FrontendTasks.*;


public class PremierAffichage {
	
	public static void creerTaches(FrontendTasks tasks) {
		
		
		tasks.taskGroup("PremierAffichage")

		     .waitsFor("ViewLoaders")
		     
		     .contains(subTasks -> {

				creerVuePartie(subTasks);
				afficherFenetre(subTasks);
				creerDonneesVuePartie(subTasks);

		     });
	}

	private static void creerVuePartie(FrontendTasks subTasks) {

		subTasks.task(created(VuePartie.class))
		
		     .waitsFor(viewLoader(VuePartie.class))

		     .executesAndReturnsValue(inputs -> {
		    	 
		    	 ViewLoader<VuePartie> viewLoader = inputs.get(viewLoader(VuePartie.class));
		    	 
		    	 return viewLoader.createView();

			 });
	}


	private static void afficherFenetre(FrontendTasks subTasks) {

		subTasks.task("afficherFenetre")
		
		     .waitsFor(window())

		     .waitsFor(created(VuePartie.class))

		     .executes(inputs -> {
		    	 
		    	 Window    window    = inputs.get(window());
		    	 VuePartie vuePartie = inputs.get(created(VuePartie.class));
		    	 
		    	 window.installRootView(vuePartie);
		    	 
		    	 window.setTitle("Pong");
		    	 
		    	 window.show();

			 });
	}

	private static void creerDonneesVuePartie(FrontendTasks subTasks) {

		subTasks.task(create(DonneesVuePartie.class))

		     .executesAndReturnsValue(inputs -> {

					DonneesVuePartie       donneesVuePartie = new DonneesVuePartie();

					return donneesVuePartie;

			 });
	}
}
